Unit ash3e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFH3E_p;

procedure ash3e(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; N :Integer; P :Integer;
                var IR :Array of Integer; var R :Array of Extended;
                var IERR :Integer);

implementation

procedure ash3e(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; N :Integer; P :Integer;
                var IR :Array of Integer; var R :Array of Extended;
                var IERR :Integer);
var
I,L,N0,JX,I1,IDET,NN,NN1,K,N1,J :Integer;
ZERO,SAVE :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17;
begin
IERR := 0;
N1 := N+1;
ZERO := 0.e0;
if ( P <> 1 ) 
 then goto _1;
AFH3E(A,N,IR,R,IERR);
if ( IERR <> 0 ) 
 then goto _17;
_1:
if ( N = 1 ) 
 then goto _7;
for I:=1 to N do
 begin
  SAVE := B[I-1];
  J := IR[I-1];
  B[I-1] := B[J-1];
  B[J-1] := SAVE;
_2:
 end;
for I:=1 to N do
 begin
_3:
  X[I-1] := B[I-1];
 end;
L := 1;
N0 := N-1;
for I:=1 to N0 do
 begin
  JX := L+I;
  I1 := I+1;
  L := L+I1;
  SAVE := X[I-1];
  if ( SAVE = ZERO ) 
   then goto _6;
  if ( IR[N+I-1] <> 2 ) 
   then goto _4;
  JX := JX+I1;
  I1 := I1+1;
  if ( I1 > N ) 
   then goto _6;
_4:
  for J:=I1 to N do
   begin
    X[J-1] := X[J-1]-A[JX-1]*SAVE;
    JX := JX+J;
_5:
   end;
_6:
 end;
_7:
L := 0;
IDET := 1;
for I:=1 to N do
 begin
  L := L+I;
  if ( IR[N+I-1]-1.0 ) < 0
   then goto _8
   else if ( IR[N+I-1]-1.0 ) > 0
         then goto _10
         else goto _9;
_8:
  X[I-1] := (X[I-1]*A[L-I-1]-SAVE*A[L-2])/R[IDET-1];
  IDET := IDET+1;
  goto _11;
_9:
  X[I-1] := X[I-1]/A[L-1];
  goto _11;
_10:
  SAVE := X[I-1];
  X[I-1] := (SAVE*A[L+I+0]-X[I+0]*A[L+I-1])/R[IDET-1];
_11:
 end;
NN := N0;
if ( IR[N+N-1] = 0 ) 
 then NN := NN-1;
if ( NN < 1 ) 
 then goto _15;
NN1 := NN+1;
L := (NN*NN1) div 2+NN;
for K:=1 to NN do
 begin
  I := NN1-K;
  I1 := I+1;
  JX := L;
  L := L-I1;
  SAVE := X[I-1];
  if ( IR[N+I-1] <> 2 ) 
   then goto _12;
  JX := JX+I1;
  I1 := I1+1;
_12:
  for J:=I1 to N do
   begin
    SAVE := SAVE-A[JX-1]*X[J-1];
    JX := JX+J;
_13:
   end;
  X[I-1] := SAVE;
_14:
 end;
_15:
for K:=1 to N do
 begin
  I := N1-K;
  SAVE := X[I-1];
  J := IR[I-1];
  X[I-1] := X[J-1];
  X[J-1] := SAVE;
_16:
 end;
_17:
end;

end.
